import fischertechnik.factories as txt_factory
import threading
import datetime
import imutils
import time
import cv2 #picutre read
import socket #for getting IP

from lib.controller import *
from flask import Response
from flask import Flask
from flask import render_template
from lib.video_feed import *
from lib.display import *


infotext = None
Cam_on = None
lock = None
outputFrame = None
ServApp = None
def video_app():
    global infotext, Cam_on, lock, outputFrame, ServApp
    infotext = ''
    Cam_on = False
    lock = None
    outputFrame = None
    ServApp = None
    #start camera
    TXT_M_USB1_1_camera.start()
    time.sleep(3)
    threading.Thread(target=frame_get, daemon=True).start()
    #define APP
    # initialize a flask object

    app = Flask(__name__)

    @app.route("/")
    def index():
    	# return the rendered template
    	return render_template("index.html")

    @app.route("/video_feed")
    def video_feed():
    	# return the response generated along with the specific media
    	# type (mime type)
    	return Response(generate(),
    		mimetype = "multipart/x-mixed-replace; boundary=frame")
    #your python code
    hostname = socket.gethostname()
    ip = socket. gethostbyname(hostname)

    #ip = 'localhost'
    port = '9999'

    infotext =str('http://'+ip+':'+port+'/video_feed')

    print(infotext)
    display.set_attr("campic_info.text", str(infotext))
    #your python code

    app.run(host=ip, port=port, debug=True, threaded=True, use_reloader=False)



def frame_get():
    global infotext, Cam_on, lock, outputFrame, ServApp
    #your python code
    lock = threading.Lock()
    #your python code

    #camera = Txt.get_instance().get_camera()
    while True:
            if Cam_on:
                success, frame, _ = TXT_M_USB1_1_camera.read()
                frame = imutils.resize(frame, width=640)
            #if success and frame is not None:
            #    frame = TXT_M_USB1_1_camera.frame_to_jpg(frame, 30)
                with lock:
                    outputFrame = frame.copy()
            else:
                    pass



def on_txt_switch_toggled(event):
    global infotext, Cam_on, lock, outputFrame, ServApp
    if display.get_attr("txt_switch.checked"):
        print('turn Cam on')
        Cam_on = True
    if not (display.get_attr("txt_switch.checked")):
        print('turn Cam off')
        Cam_on = False


def generate():
    global infotext, Cam_on, lock, outputFrame, ServApp
    #your python code
    global outputFrame, lock
    # loop over frames from the output stream
    while True:
    	# wait until the lock is acquired
    	with lock:
    	        # check if the output frame is available, otherwise skip
    		# the iteration of the loop
    		if outputFrame is None:
    			continue
    		# encode the frame in JPEG format
    		(flag, encodedImage) = cv2.imencode(".jpg", outputFrame)
    		# ensure the frame was successfully encoded
    		if not flag:
    			continue
    		# yield the output frame in the byte format
    	yield(b'--frame\r\n' b'Content-Type: image/jpeg\r\n\r\n' +
    		bytearray(encodedImage) + b'\r\n')



#from multiprocessing import Process
display.switch_toggled("txt_switch", on_txt_switch_toggled)


